Package com.sun.grid.ca

# Interface GridCA

All Known Implementing Classes:
  `GridCAImpl`

public interface GridCA
This interface defines all methods which can be exeucted on the Grid Certificate Authority.

## Method Summary

Modifier and Type
Method
Description
`void`
`createDaemon(String daemon, String user, String email)`
Create private key and certificate for a sdm daemon.
`KeyStore`
`createDaemonKeyStore(String daemon)`
Get the keystore for a daemon.
`KeyStore`
`createKeyStore(String username, char[] keystorePassword, char[] privateKeyPassword)`
Create a keystore which contains the private key and certificate of an user.
`KeyStore`
`createSGEDaemonKeyStore(String daemon, char[] keystorePassword, char[] privateKeyPassword)`
Get the keystore for an SGE daemon.
`void`
`createUser(String username, String email)`
Create private key and certificate for a user.
`void`
`createUser(String username, String gecos, String email)`
Deprecated.
the gecos field is no longer used, use @{link #createUser(String,String)} instead
`X509Certificate`
`getCertificate(String username)`
Get the X.509 certificate of a user.
`X509Certificate`
`getDaemonCertificate(String daemon)`
Get the X.509 certificate of a daemon.
`void`
`init(InitCAParameters params)`
Initialize the Grid CA
`void`
`renewCaCertificate(int days)`
Renew the certificate of the certificate authority
`X509Certificate`
`renewCertificate(String username, int days)`
Renew the certificate of a user.
`X509Certificate`
`renewDaemonCertificate(String daemon, int days)`
Renew the certificate of a daemon.

## Method Details

### init

void init(InitCAParameters params) throws GridCAException
Initialize the Grid CA

Parameters:
  `params` - parmeters for the CA
Throws:
  `GridCAException`

### createUser

void createUser(String username, String gecos, String email) throws GridCAException
Deprecated.
the gecos field is no longer used, use @{link #createUser(String,String)} instead
Create private key and certificate for a user.

Parameters:
  `username` - name of the user
  `gecos` - gecos of the user
  `email` - email address of the user
Throws:
  `GridCAException` - if the creation of the private key or the certificate fails

### createUser

void createUser(String username, String email) throws GridCAException
Create private key and certificate for a user.

Parameters:
  `username` - name of the user
  `email` - email address of the user
Throws:
  `GridCAException` - if the creation of the private key or the certificate fails

### getCertificate

X509Certificate getCertificate(String username) throws GridCAException
Get the X.509 certificate of a user.

Parameters:
  `username` - name of the user
Returns:
  X.509 certificate
Throws:
  `GridCAException` - if the certificate does not exist

### getDaemonCertificate

X509Certificate getDaemonCertificate(String daemon) throws GridCAException
Get the X.509 certificate of a daemon.

Parameters:
  `daemon` - common name of the daemon
Returns:
  X.509 certificate
Throws:
  `GridCAException` - if the certificate does not exist

### createKeyStore

KeyStore createKeyStore(String username, char[] keystorePassword, char[] privateKeyPassword) throws GridCAException
Create a keystore which contains the private key and certificate of an user.

Parameters:
  `username` - name of the user
  `keystorePassword` - password used to encrypt the keystore
  `privateKeyPassword` - password used to encrypt the key
Throws:
  `GridCAException` - if the keystore could not be created

### renewCertificate

X509Certificate renewCertificate(String username, int days) throws GridCAException
Renew the certificate of a user.

Parameters:
  `username` - name of the user
  `days` - validity of the new certificate in days
Returns:
  the renewed certificate

### renewDaemonCertificate

X509Certificate renewDaemonCertificate(String daemon, int days) throws GridCAException
Renew the certificate of a daemon.

Parameters:
  `daemon` - name of the daemon
  `days` - validity of the new certificate in days
Returns:
  the renewed certificate
Throws:
  `GridCAException` - if the certificate can not be renewed

### renewCaCertificate

void renewCaCertificate(int days) throws GridCAException
Renew the certificate of the certificate authority

Parameters:
  `days` - validity of the new certificate in days
Throws:
  `GridCAException` - if the certificate can not be renewed

### createDaemon

void createDaemon(String daemon, String user, String email) throws GridCAException
Create private key and certificate for a sdm daemon.

Parameters:
  `daemon` - name of the daemon
  `user` - username of the daemon (owner of the process)
  `email` - email address of the process owner
Throws:
  `GridCAException` - if the create of the daemon failed

### createDaemonKeyStore

KeyStore createDaemonKeyStore(String daemon) throws GridCAException
Get the keystore for a daemon. This method can be used be the installation to create keystore for the daemon of a sdm system.

Parameters:
  `daemon` - name of the daemon
Returns:
  the keystore of the daemon
Throws:
  `GridCAException`

### createSGEDaemonKeyStore

KeyStore createSGEDaemonKeyStore(String daemon, char[] keystorePassword, char[] privateKeyPassword) throws GridCAException
Get the keystore for an SGE daemon. This method can be used to create a keystore for the daemon of a SGE system.

Parameters:
  `daemon` - name of the daemon
  `keystorePassword` - password used to encrypt the keystore
  `privateKeyPassword` - password used to encrypt the key
Returns:
  the keystore of the daemon
Throws:
  `GridCAException`